﻿using System;
using System.Linq;
using System.Windows;
using System.Windows.Input;
using Telerik.Windows.Controls.Diagrams;
using Telerik.Windows.Diagrams.Core;

namespace Diagram_WPF_RightButtonPanning
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ToolService toolService { get; set; }
        MyPanningTool myPan { get; set; }

        public MainWindow()
        {
            InitializeComponent();
            this.toolService = this.diagram.ServiceLocator.GetService<IToolService>() as ToolService;
            this.diagram.MouseRightButtonDown += OnDiagramMouseRightButtonDown;
            this.diagram.MouseRightButtonUp += OnDiagramMouseRightButtonUp;
            this.myPan = new MyPanningTool();
            this.toolService.ToolList[0] = new MyPointer();
            this.toolService.ToolList[4] = this.myPan;
            this.toolService.ActivateTool("Pointer Tool");
        }
        void OnDiagramMouseRightButtonUp(object sender, MouseButtonEventArgs e)
        {
            this.toolService.IsMouseDown = false;
            var position = e.GetPosition(this.diagram);
            var transformedPosition = this.diagram.GetTransformedPoint(position);
            this.myPan.MouseUp(new PointerArgs(position, transformedPosition));
        }

        void OnDiagramMouseRightButtonDown(object sender, MouseButtonEventArgs e)
        {
            var position = e.GetPosition(this.diagram);
            var transformedPosition = this.diagram.GetTransformedPoint(position);
            this.myPan.MouseDown(new PointerArgs(position, transformedPosition));
        }
    }
  
    public class MyPointer : PointerTool
    {
        public override bool MouseMove(PointerArgs e)
        {
            var result = base.MouseMove(e);
            if (this.IsActive && Mouse.RightButton == MouseButtonState.Pressed)
            {
                this.ToolService.ActivateTool("MyPanning");
                this.ToolService.IsMouseDown = true;
            }
            return result;
        }
    }
}
